import Sketch.Scripting
from Sketch import Issue
from Sketch.const import REDRAW
from Sketch.UI.sketchdlg import SketchPanel
from pyshell import Shell

class SkShell(Shell):
    def __init__(self, parent, namespace, document, *args, **kw):
        self.sketch_doc = document
        apply(Shell.__init__,(self, parent, namespace)+args, kw)
        
    def Execute(self, input):
        doc = self.sketch_doc
        doc.BeginTransaction('pyShell executes input')
        self.swapStdFiles()
        try:
            try:
                self.shell.push(input)
            except:
                doc.AbortTransaction()  
        finally:
            doc.EndTransaction()
            self.swapStdFiles()

        # repaint the canvas & update the selection
        # XXX is there a better way to do this ?
        sel = doc.SelectedObjects()
        doc.SelectNone()
        Issue(doc, REDRAW, 1)
        doc.SelectObject(sel)

class ScriptingWindow(SketchPanel):
    title = "Python Scripting"
    def __init__(self, master, context, namespace = {}):
        main_window = context.main_window
        self.doc = context.document
        self.namespace = namespace
        namespace['self'] = self
        SketchPanel.__init__(self, master, main_window, self.doc,
                             name = "scriptingwindow")

    def build_dlg(self):
        shell = SkShell(self.top, self.namespace, self.doc, width=40, \
                        font=('courier', 12))
        shell.pack(fill = 'both', expand = 1)
        self.shell = shell

def open_scriptingwindow(context):
    namespace = {}
    namespace['context'] = context
    namespace['doc'] = context.document
    namespace['Sketch'] = Sketch

    window = ScriptingWindow(context.application.root, context, namespace)
                             

