def Undo(func, *args, **kw):
    if func == None: return
    return [(func, args, kw),]

class UndoStack:
    def __init__(self):
        self.clear_undo()

    def clear_undo(self):
        self.undo_stack = []
        self.redo_stack = []

    def add_undo(self, undo_info):
        if undo_info == None: return
        self.undo_stack.append(undo_info)
        self.redo_stack = []

    def undo(self):
        if self.has_undo():
            undo_info = self.undo_stack.pop()
            redo_info = []
            for info in undo_info:
                redo_info = redo_info + apply(info[0], info[1], info[2])
            self.redo_stack.append(redo_info)

    def redo(self):
        if self.has_redo():
            redo_info = self.redo_stack.pop()
            undo_info = []
            for info in redo_info:
                undo_info = undo_info + apply(info[0], info[1], info[2])
            self.undo_stack.append(undo_info)

    def has_undo(self):
        return len(self.undo_stack)>0

    def has_redo(self):
        return len(self.redo_stack)>0


if __name__=='__main__':

    class test(UndoStack):
        def __init__(self):
            UndoStack.__init__(self)
            self.v = 0
        def add(self, v):
            self.v = self.v + v
            return Undo(self.sub, v)
        def sub(self, v):
            self.v = self.v - v
            return Undo(self.add, v)


    o = test()
    undo_info = o.add(10)
    o.add_undo(undo_info)
    print "add: ",o.v
    o.undo()
    print "undo:",o.v
    o.redo()
    print "redo",o.v

